import re


######## luhn 算法  ############

def luhn_checksum(card_number):
    def digits_of(n):
        return [int(d) for d in str(n)]
 
    digits = digits_of(card_number)
    odd_digits = digits[-1::-2]
    even_digits = digits[-2::-2]
    checksum = 0
    checksum += sum(odd_digits)
    for d in even_digits:
        d_0 = 2*d
        d_1 = d_0 // 10
        d_2 = d_0 % 10
        checksum += d_1
        checksum += d_2
 
    return checksum % 10

#########    匹配函数  ###############

def f(head,tail,text):
    ans = []
    reses = re.findall("("+head + tail+")", text)
    for res in reses:
        ans.append(res[0])
    return ans

ff = open("result.txt", "a")
ff.write("Now the file has more content!\n")


#### phone ####
texts = open('./sens_data.txt', 'r').readlines()
heads = open('./phone_head.txt', 'r').readlines()
tail = "([\\-|\s])(\d)(\d)(\d)(\d)([\\-]|[\s])(\d)(\d)(\d)(\d)"


for ii in range(len(texts)):
    text = texts[ii]

    for head in heads:
        ans = f("\s" + head.strip(), tail, text)
        for i in ans:
            print(ii + 1, "PhoneNo", i[1:])
            ff.write(str(ii + 1) + ",PhoneNo," + str(i[1:]))
            ff.write("\n")    


######### IMEI #####
    
texts = open('./sens_data.txt', 'r').readlines()
heads = open('./IMEI_head.txt', 'r').readlines()
tail = "(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)(\d)"





for ii in range(len(texts)):
    text = texts[ii]

    for head in heads:
        ans = f("\s" + head.strip(), tail, text)
        for i in ans:
            if luhn_checksum(i[1:-1]) == int(i[-1]):
                print(ii + 1, "IMEI", i[1:])
                ff.write(str(ii + 1) + ",IMEI," + str(i[1:]))
                ff.write("\n")

##### bankcard #####

texts = open('./sens_data.txt', 'r').readlines()
heads = open('./bankcard_head.txt', 'r').readlines()
tail = "(\d{10,16})"


for ii in range(len(texts)):
    text = texts[ii]

    for head in heads:
        ans = f("\s" + head.strip(), tail, text)
        for i in ans:
            # if luhn_checksum(i[1:-1]) == int(i[-1]):
                # print(i[1:])
            print(ii + 1, "BankCard", i[1:])
            ff.write(str(ii + 1) + ",BankCard," + str(i[1:]))
            ff.write("\n")

#### ipv4 ####

head = "(25[0-5]|2[0-4]\d|[0-1]\d{2}|[1-9]?\d)\.(25[0-5]|2[0-4]\d|[0-1]\d{2}|[1-9]?\d)\.(25[0-5]|2[0-4]\d|[0-1]\d{2}|[1-9]?\d)\.(25[0-5]|2[0-4]\d|[0-1]\d{2}|[1-9]?\d)"
texts = open('./sens_data.txt', 'r').readlines()
for ii in range(len(texts)):
    text = texts[ii]
    ans = f(head, '', text)
    for i in ans:

        print(ii + 1, "IPv4", i[0:])
        ff.write(str(ii + 1) + ",IPv4," + str(i[0:]))
        ff.write("\n")



######## Email ####

head = "\w[-\w.+]*@([A-Za-z0-9][-A-Za-z0-9]+\.)+[A-Za-z]{2,14}"
text = open('./sens_data.txt', 'r').readlines()
for ii in range(len(texts)):
    text = texts[ii]
    ans = f(head, '', text)
    for i in ans:

        print(ii + 1, "Email", i[0:])
        ff.write(str(ii + 1) + ",Email," + str(i[0:]))
        ff.write("\n")




ff.close()
exit()
